Index: sys/netinet6/icmp6.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet6/icmp6.c,v
retrieving revision 1.80.2.4
diff -u -p -r1.80.2.4 icmp6.c
--- sys/netinet6/icmp6.c	31 Aug 2008 21:54:24 -0000	1.80.2.4
+++ sys/netinet6/icmp6.c	1 Sep 2008 23:03:44 -0000
@@ -1117,6 +1117,15 @@ icmp6_mtudisc_update(struct ip6ctlparam 
 	if (!validated)
 		return;
 
+	/*
+	 * In case the suggested mtu is less than IPV6_MMTU, we
+	 * only need to remember that it was for above mentioned
+	 * "alwaysfrag" case.
+	 * Try to be as close to the spec as possible.
+	 */
+	if (mtu < IPV6_MMTU)
+		mtu = IPV6_MMTU - 8;
+
 	bzero(&inc, sizeof(inc));
 	inc.inc_flags = 1; /* IPv6 */
 	inc.inc6_faddr = *dst;
